SystemOrganization addCategory: #'OCMS-Interface'!

WAFileLibrary subclass: #OCMSFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSFileLibrary methodsFor: 'as yet unclassified' stamp: 'oda 6/29/2013 23:38'!
ocmsCss
^'body {
	font-family: 			Georgia, "Times New Roman", Times, serif;
	font-size: 			small;
}
#allcontent {
	width: 				770px;
	padding-top: 		5px;
	padding-bottom: 	5px;
	background-color: 	#fff0d0;
	margin-left: 		auto;
	margin-right: 		auto;
}
*.section {
	background-color: 	#ffeabf;
}
#header {
	margin: 				10px;
}
#main {
	padding: 			15px;
	margin: 				0px 10px 10px 10px;
	width: 				550px;
	float: 				right;
}
#sidebar {
	padding: 			15px;
	margin: 				0px 600px 10px 10px;
}
#footer {
	color: 				#204670;
	text-align: 			center;
	padding: 			15px;
	margin: 				10px;
	clear: 				right;
}'! !

WASession subclass: #OCMSSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 20:42'!
user
	^user! !

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 22:23'!
user: anUser
	user := anUser.! !

WAComponent subclass: #CommentAddView
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CommentAddView methodsFor: 'initialization' stamp: 'has 6/29/2013 20:14'!
initialize
	super initialize.
	comment := Comment new.! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:20'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: comment];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:18'!
renderContentOn: html
	html heading level: 1; with: 'New comment'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderTextOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:54'!
renderTextOn: html
	html div: [
		html label: 'Your comment'.
		html textArea
			callback: [:value | comment text: value.
							comment dateAndTime: DateAndTime now.
							"comment user:'User session'."
						].
	].! !

WAComponent subclass: #CoursewareDetailsView
	instanceVariableNames: 'courseware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareDetailsView methodsFor: 'updating' stamp: 'has 6/29/2013 20:44'!
addComment
	| comment component |
	component  := CommentAddView new.
	comment := self call: component.
	
	(comment isMemberOf: Comment)
		ifTrue: [
				[	
					(CoursewareManager new) includeComment: courseware comment: comment.
					self inform: ('Your comment was successfully registered.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not add the comment due to ', sig asString)].
		].! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:12'!
back
	self answer.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:44'!
courseware
	^courseware.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:43'!
courseware: aCourseware
	courseware:= aCourseware.! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 21:11'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: courseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Back to Coursewares'.
	html break.
	html table:[
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Id'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Description'.
						html tableData: courseware description.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Summary'.
						html tableData: courseware summary.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courseware type'.
						html tableData: courseware coursewareType.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Owner'.
						html tableData: courseware owner username.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Reference'.
						html tableData: courseware reference.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Tag'.
						html tableData: [courseware tagString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Course'.
						html tableData: [courseware courseString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Author'.
						html tableData: courseware authorString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Created at:'.
						html tableData: courseware creationDateTime asTimeStamp.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Modified at:'.
						html tableData: courseware modificationDateTime.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Cataloguing data'.
						html tableData: courseware cataloguingData.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'License'.
						html tableData: courseware license asString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'File name'.
						html tableData: courseware file.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Size'.
						html tableData: courseware size.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'No. downloads'.
						html tableData: courseware downloadCounter.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Enabled'.
						html tableData: courseware isEnabled.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Write users'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Rating score'.
						html tableData: courseware calculateRatingScore.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Download'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Comments'.
						html tableData: courseware id.].
			].
	html break.
	html anchor
		callback: [self addComment];
		with: 'Add a comment'.
	html break.
	html heading level: 3;
		with: 'Comments'.
	html table:[ courseware comment do: [:each | 
		html tableRow:[
						(html tableHeading) align:'left'; with: 'User'.
						html tableData: (each login).
		].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Comment'.
						html tableData: (each text).].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Date'.
						html tableData: (each dateAndTime asTimeStamp).
		].
		]].! !

WAComponent subclass: #CoursewareEditView
	instanceVariableNames: 'courseware tagValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 11:38'!
addTag: aTag
	| component newTag tagList tagManager tagTemp |
	tagTemp := aTag trimBoth.
	component  := self.
	tagList := self courseware tag.
	tagManager := TagManager new.
	newTag:= Tag new.
	[
		((tagTemp = ''))
			ifFalse:[
						(Tags labelExists: tagTemp)
							ifFalse:[tagManager includeTag: tagTemp].
						(courseware tagExists: tagTemp)
							ifFalse:[	newTag label: tagTemp.
									tagList add: newTag.
									courseware tag: tagList.
									self inform: ('The tag was successfully registered.').]
							ifTrue:[self inform: ('The tag already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null tags cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware
	^courseware! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware: aCourseware
	courseware:=aCourseware.! !

!CoursewareEditView methodsFor: 'initialization' stamp: 'has 6/29/2013 21:25'!
initialize
	super initialize.! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/29/2013 23:32'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: courseware];
			with: 'Save'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 09:02'!
renderContentOn: html
	html heading level: 1; with: 'Edit Courseware'.
	html text: 'Edit courseware information'. 
	
	html form: [
		self
			renderTitleOn: html;
			renderSummaryOn: html;
			renderDescriptionOn: html;
			renderCoursewareTypeOn: html;
			renderOwnerOn: html;
			renderTagsOn: html;
			renderTagsAddOn: html;
			renderButtonsOn: html; 
			yourself.  
	].  ! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:24'!
renderCoursewareTypeOn: html
	html div: [
		html label: 'CoursewareType:'.
		html select 
            	list: CoursewareType coursewareTypeList; 
            	on: #coursewareType of: self courseware;
			callback: [:value | courseware coursewareType: value].
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:27'!
renderDescriptionOn: html
	html div: [
		html label: 'Description:'.
		html textArea
			callback: [:value | courseware description: value];
			with: courseware description.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:12'!
renderOwnerOn: html
	html div: [
		html label: 'Owner:'.
		html label: courseware owner username.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:15'!
renderReferenceOn: html
	html div: [
		html label: 'Reference:'.
		html textArea
			callback: [:value | courseware reference: value];
			with: courseware reference.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:29'!
renderSummaryOn: html
	html div: [
		html label: 'Summary:'.
		html textArea
			callback: [:value | courseware summary: value];
			with: courseware summary.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 09:44'!
renderTagsAddOn: html
	html div: [
		html label: 'Add Tags:'.
		html textInput
			callback:[:value | tagValue := value].
		html space.
		html button
			callback: [self addTag: tagValue ];
			with: 'Add'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:25'!
renderTagsOn: html
	html div: [
		html label: 'Tags:'.
		html label: courseware tagString.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 08:17'!
renderTagsSearchOn: html for: type
	html div: [
		html label: 'Add Tags:'.
		html searchInput
			id: ('inputfield');
			onSearch: (Tags searchTagByLabel: type);
			onKeyUp: (Tags searchTagByLabel: type).
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:29'!
renderTitleOn: html
	html div: [
		html label: 'Title:'.
		html textArea 
			callback: [:value | courseware title: value];
			with: courseware title.
	].! !

WAComponent subclass: #CoursewareListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 11:14'!
back
	self answer.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:07'!
coursewareDetails: aCourseware on: html
	
	html heading level: 1; 
		with: aCourseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Coursewares'.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 21:25'!
editCourseware: aCourseware
	| component courseware |
	component  := CoursewareEditView new.
	component courseware: aCourseware.
	courseware := self call: component.
	
	(courseware isMemberOf: Courseware)
		ifTrue: [
				[
					(CoursewareManager new) updateCourseware: courseware.
					self inform: ('Courseware successfully updated.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not update due to ', sig asString)].
		].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 14:58'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: 'Coursewares'.
	html break.
	html anchor
		callback: [self back];
		with: 'Home'.
	html unorderedList: [self renderItemsOn: html].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:05'!
renderItem: aCourseware on: html
	
	html listItem
		with: [html text: aCourseware title.
				html space.
				html anchor
					callback:[self showCoursewareDetails: aCourseware];
					with: 'details'.
				html space.
				html anchor
					callback:[self editCourseware: aCourseware];
					with: 'edit'.
				].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 13:25'!
renderItemsOn: html
	| coursewareList batchedList coursewareTitleList selection |
	coursewareList:= Coursewares getAll.
	coursewareList do:[:each | self renderItem: each on: html].
	"coursewareTitleList :=  OrderedCollection new.
	coursewareList do:[:each | coursewareTitleList add: each title]."
	"batchedList := WABatchedList new.
	batchedList items: coursewareTitleList asArray.
	batchedList batchSize: 10."
	"batchedList renderContentOn: html."
	"selection:= WABatchSelection items: coursewareList link: #id text: #title.
	selection batchSize: 20.
	selection onAnswer: [:item | self renderItem: item on:html]. 
	html render: selection."! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 16:12'!
showCoursewareDetails
	self call: (CoursewareDetailsView new).! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:04'!
showCoursewareDetails: aCourseware
	| coursewareDV |
	coursewareDV:=CoursewareDetailsView new.
	coursewareDV courseware: aCourseware.
	self call: (coursewareDV).! !

WAComponent subclass: #LoginComponent
	instanceVariableNames: 'login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!LoginComponent methodsFor: 'operating' stamp: 'oda 6/29/2013 23:17'!
authenticateUser
	| user |
	user := (UserManager new)
		authenticateUserWithLogin: login
		withPassword: password.
		self session user: user.
	user notNil
		ifTrue: [
			login := nil.
			password := nil.
			"self call: (UserHome on: user)."
		]! !

!LoginComponent methodsFor: 'operating' stamp: 'oda 6/29/2013 23:17'!
registerUser
	| component answer |
	component  := UserRegistrationView new.
	answer := self call: component.
	
	(answer isMemberOf: User)
		ifTrue: [
				[
					(UserManager new) includeUser: answer.
					self inform: ('User successfully registered.', String lf, 'Wait for an admin unlock your account.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not register due to ', sig asString)].
		].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:05'!
renderContentOn: html
	self session user isNil ifTrue: [
		self renderFormOn: html.  
	] ifFalse: [
		html heading: 'Welcome ', self session user login.
	]  
! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:07'!
renderFormOn: html
	html form
		class: 'loginForm';
		with: [ 
			self 
				renderWarningOn: html;
				renderLoginOn: html;
				renderPasswordOn: html;
				renderSubmitOn: html;
				yourself.
		].
	html anchor
		callback: [self registerUser];
		with: 'Register'.! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:07'!
renderLoginOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:33'!
renderPasswordOn: html
	html div: [ 
		html label: 'Password:'.
		html passwordInput
			callback: [:value | password := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 23:17'!
renderSubmitOn: html
	html div: [ 
		html submitButton
			callback: [self authenticateUser];
			with: 'Login'.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:05'!
renderUserOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:24'!
renderWarningOn: html
	html div: [
		html
			span: self warning;
			yourself.
	].! !

!LoginComponent methodsFor: 'operating' stamp: 'oda 6/29/2013 20:24'!
warning
	self session user notNil
		ifTrue: [	^'Logged in as ' , self session user login.].

	(login isNil or: [login isEmpty])
		ifTrue: [	^'Please enter User ID and Password'.].

	^'Login failed!!'.! !

WAComponent subclass: #OCMSHome
	instanceVariableNames: 'mainArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSHome class methodsFor: 'root' stamp: 'monnacs 6/26/2013 21:06'!
canBeRoot

 
^true! !

!OCMSHome class methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 20:10'!
initialize
"
	OCMSHome initialize
"
	super initialize.
	(self registerAsApplication: 'ocms')
		preferenceAt: #sessionClass put: OCMSSession;
		yourself.! !

!OCMSHome methodsFor: 'initialize-release' stamp: 'oda 6/30/2013 01:46'!
initialize
	| user |
	super initialize.
	
	user := self session user.
	! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:16'!
renderContentOn: html
	"I render everything by calling html"
	html div
		id: 'allcontent';
		with: [
			self
				renderHeaderOn: html;
				renderMainOn: html;
				renderSidebarOn: html;  
				renderFooterOn: html;
				yourself.
		].! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:08'!
renderFooterOn: html
	html div
		id: 'footer';
		class: 'section';
		with: [
			html text: 'footer?'.
		].! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:07'!
renderHeaderOn: html
	html div
		id: 'header';
		class: 'section';
		with: [
			html heading
				level1;
				with: 'Open Courseware Management System'.
			html text: 'A system to store and share open courseware to academic institutions.'.
		].! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:16'!
renderHomeAnchor: html
	html anchor
		callback: [ mainArea := CoursewareListView new ];
		with: 'Home'.
	html break! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:51'!
renderLoginAnchorOn: html
	html anchor
		callback: [mainArea := LoginComponent new];
		with: 'Login'.! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:17'!
renderLogoutAnchorOn: html
	html anchor
		callback: [self session user: nil];
		with: 'Logout'.! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:34'!
renderMainOn: html
	| user |
	user := self session user.
	html div
		id: 'main';
		class: 'section';
		with: [ html render: mainArea ].
! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:15'!
renderSidebarOn: html
	html div
		id: 'sidebar';
		class: 'section';
		with: [ 
			html heading
				level2;
				with: 'Menu'.
			self renderHomeAnchor: html.
			self renderUserOn: html
		]! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:51'!
renderUserOn: html
	self session user isNil ifTrue: [
		self renderLoginAnchorOn: html.
	] ifFalse: [
		self renderLogoutAnchorOn: html.
	].
	html break.! !

!OCMSHome methodsFor: 'updating' stamp: 'oda 6/29/2013 23:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'OCMS'.
	anHtmlRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: OCMSFileLibrary / 'ocms.css';
		yourself.

	"old css
	anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css'"
! !

WAComponent subclass: #UserRegistrationView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UserRegistrationView methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 18:18'!
initialize
	super initialize.
	user := User new.! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:39'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: user];
			with: 'Register'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:19'!
renderContentOn: html
	html heading level: 1; with: 'User Registration'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderLoginOn: html;
			renderPasswordOn: html;
			renderUsernameOn: html;
			renderEmailOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderEmailOn: html
	html div: [
		html label: 'Email:'.
		html textInput
			callback: [:value | user email: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:35'!
renderLoginOn: html
	html div: [
		html label: 'Login:'.
		html textInput
			callback: [:value | user login: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:24'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value | user password: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderUsernameOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | user username: value].
	].! !
OCMSHome initialize!
